#include "unithorpe3.h"

th G;

int getu()
{
	int c= getchar();
	if (c=='\\') {
		int x= getchar();
		if (x<' ') return getu();
		int y= getchar();
		ASSERT( ' '<y );
		c= (x<<8)&0xFF00;
		c+= (y)&0x00FF;
	}
	return c;
}

void do_script()
{
	th a;
	int v, c;
	int i;
	while ( 0 <= (v=getu()) ) {
		// v has the variable slot being defined
		
		a= anew();
		i= 0;

		// read in rest of line
		while ( ' ' <= (c=getu()) || c=='\t' ) {
			aput( a, i, c );
			++i;
		}
		aput( G, v, a );
	}
}

int main(int argc, char** argv)
{
	int e;
	th a;
	char* cp;
	int i;


	G= anew();
	alink(G);
	bc_init(G);

	do_script();

	if (argc==2) {
		debug= 1;
	}
	P( "----------------------------------------------------------------\n", e );

	e= loop( G, 'M' );

	P( "----------------------------------------------------------------\n", e );

	for (i='A'; i<='Z'; i++) {
		th x= aget( G, i );
		if (x) P("[%c]=%lu ", i, x );
	}
	for (i='a'; i<='z'; i++) {
		th x= aget( G, i );
		if (x) P("[%c]=%lu ", i, x );
	}
	P( "----------------------------------------------------------------\n", e );

	if (1 || argc>=2) {
	   int uc;
	   for (uc=0; uc<64; uc+=32) {
		for (i=uc+'A'; i<=uc+'Z'; i++) {
			th v= aget(G, i);
			if (!v) continue;
			printf("[%c] ", i);
			if (ISINT(v)) {
				printf("%c %lu\n", 32<=v&&v<127? v : ' ', v );
			} else {
				int j;
				int cap= ARR(v)->cap;
				for (j=0; j<cap; j++) {
					th x= aget( v, j);
					if (32<=x && x<=126) putchar(x);
					else if (x==0) { if (j<128) printf("~"); }
					else if (x<256*256) printf("{%lu\\%c%c}", x, hi(x),lo(x) );
					else printf("{%lu}", x );
				}
				putchar( '\n' );
			}
		}
	   }
	}


	P( "  EXIT=%d\n", e );

	return e;
}
